#include <mpi.h>
#include <iostream>
#include <string.h>

using namespace std;

int main(int argc, char *argv[]){
	const int n=1000000000;
	int myrank, size;
	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	double w = 1.0/n;
	double sum=0.0,globalsum=0.0;
	for(int j=0; j<=500; j++) {
	sum=0.0;
	for(int i=myrank+1; i<=n; i+=size){
		double x=w*((double)i-0.5);
		sum +=4.0/(1.0+x*x);
	}
	}
	// Möglichkeit 1: MPI_Reduce
	//MPI_Reduce(&sum,&globalsum,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
	
	//Möglichkeit 2: MPI_Send
	double zwischensumme = 0.0;
	int from = 0;
	int to = 0;
	MPI_Status status;
	if(myrank!=(size-1)){
		from=(myrank+1); 
		cout << "Empfange von Prozess " << from << endl;
		MPI_Recv (&zwischensumme,1,MPI_DOUBLE,from,0,MPI_COMM_WORLD,&status); 
		zwischensumme+=sum;
	}
	if(myrank!=0){
		to=(myrank-1); 
		cout << "Sende an Prozess " << to << endl;
		MPI_Send (&zwischensumme,1,MPI_DOUBLE,to,0,MPI_COMM_WORLD);
	}
	if(myrank==0){
		cout << "Zwischensumme: " << zwischensumme << endl;
		zwischensumme += sum;
                globalsum = zwischensumme;
	}
	
	
	if(myrank==0){
		double pi=w*globalsum;
//		printf("pi=%.lf\n",pi);
		cout << "pi=" << pi << endl;
	}
	MPI_Finalize();
	return 0;
}
